<html>
<head>
<title>OgreInstanceBatchHW_VTF.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreInstanceBatchHW_VTF.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreInstanceBatchHW__VTF_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __InstanceBatchHW_VTF_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __InstanceBatchHW_VTF_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreInstanceBatchVTF_8h.html">OgreInstanceBatchVTF.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreTexture_8h.html">OgreTexture.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>Ogre
<a name="l00035"></a>00035 {
<a name="l00060"></a><a class="code" href="classOgre_1_1InstanceBatchHW__VTF.html">00060</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1InstanceBatchHW__VTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) and hardware instan...">InstanceBatchHW_VTF</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1BaseInstanceBatchVTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) This implementation...">BaseInstanceBatchVTF</a>
<a name="l00061"></a>00061     {
<a name="l00062"></a>00062     <span class="keyword">protected</span>:
<a name="l00063"></a><a class="code" href="group__Scene.html#ga5a827988adfc06b7d0f82833ce18cc4f">00063</a>         <span class="keywordtype">bool</span>    <a class="code" href="group__Scene.html#ga5a827988adfc06b7d0f82833ce18cc4f">mKeepStatic</a>;
<a name="l00064"></a>00064 
<a name="l00065"></a>00065         <span class="comment">//Pointer to the buffer containing the per instance vertex data</span>
<a name="l00066"></a><a class="code" href="group__Scene.html#gaee8c78087410ff8e51d4a720bbfa9d8c">00066</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="group__Scene.html#gaee8c78087410ff8e51d4a720bbfa9d8c">mInstanceVertexBuffer</a>;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068         <span class="keywordtype">void</span> setupVertices( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* baseSubMesh );
<a name="l00069"></a>00069         <span class="keywordtype">void</span> setupIndices( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* baseSubMesh );
<a name="l00070"></a>00070 
<a name="l00072"></a>00072         <span class="keywordtype">void</span> createVertexSemantics( <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *thisVertexData, <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a> *baseVertexData,
<a name="l00073"></a>00073             <span class="keyword">const</span> <a class="code" href="group__Scene.html#ga8bcdb86a2070c884c85019cdd203aabf">HWBoneIdxVec</a> &amp;hwBoneIdx, <span class="keyword">const</span> HWBoneWgtVec&amp; hwBoneWgt );
<a name="l00074"></a>00074 
<a name="l00080"></a>00080         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> updateInstanceDataBuffer(<span class="keywordtype">bool</span> isFirstTime, <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* currentCamera);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> checkSubMeshCompatibility( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a>* baseSubMesh );
<a name="l00084"></a>00084 
<a name="l00088"></a>00088         <span class="keywordtype">size_t</span> updateVertexTexture( <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *currentCamera );
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="group__Scene.html#ga5aaa014ff46d5f617d96f3aabb46d238">00090</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#ga5aaa014ff46d5f617d96f3aabb46d238" title="Affects VTF texture&#39;s width dimension.">matricesToghetherPerRow</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00091"></a>00091     <span class="keyword">public</span>:
<a name="l00092"></a>00092         <a class="code" href="classOgre_1_1InstanceBatchHW__VTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) and hardware instan...">InstanceBatchHW_VTF</a>( <a class="code" href="classOgre_1_1InstanceManager.html" title="This is the main starting point for the new instancing system.">InstanceManager</a> *creator, <a class="code" href="classOgre_1_1MeshPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MeshPtr.">MeshPtr</a> &amp;meshReference, <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> &amp;material,
<a name="l00093"></a>00093                             <span class="keywordtype">size_t</span> instancesPerBatch, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Mesh.html#a4ee5e3c78d17a1940ded9419644260ce">Mesh::IndexMap</a> *indexToBoneMap,
<a name="l00094"></a>00094                             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;batchName );
<a name="l00095"></a>00095         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1InstanceBatchHW__VTF.html" title="Instancing implementation using vertex texture through Vertex Texture Fetch (VTF) and hardware instan...">InstanceBatchHW_VTF</a>();
<a name="l00097"></a>00097         <span class="keywordtype">size_t</span> calculateMaxNumInstances( <span class="keyword">const</span> <a class="code" href="classOgre_1_1SubMesh.html" title="Defines a part of a complete mesh.">SubMesh</a> *baseSubMesh, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> flags ) <span class="keyword">const</span>;
<a name="l00098"></a>00098 
<a name="l00100"></a>00100         <span class="keywordtype">void</span> _boundsDirty(<span class="keywordtype">void</span>);
<a name="l00101"></a>00101 
<a name="l00103"></a>00103         <span class="keywordtype">void</span> setStaticAndUpdate( <span class="keywordtype">bool</span> bStatic );
<a name="l00104"></a>00104 
<a name="l00105"></a><a class="code" href="group__Scene.html#gac4adf8a45d9dbc29c9260ffb22c5a1a5">00105</a>         <span class="keywordtype">bool</span> <a class="code" href="group__Scene.html#gac4adf8a45d9dbc29c9260ffb22c5a1a5" title="Returns true if this batch was set as static.">isStatic</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mKeepStatic; }
<a name="l00106"></a>00106 
<a name="l00108"></a>00108         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateRenderQueue( <a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue );
<a name="l00109"></a>00109     };
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
